import java.util.*;

class PoPPThread extends Thread {

  static LinkedList<Thread> threads = new LinkedList();

  public interface Proc {
    void run();
  }

  Proc proc;

  PoPPThread(Proc proc) {
    this.proc = proc;
    threads.add(this);
    start();
  }
  
  public void run() {
    proc.run();
  }
  
  static void joinThreads() 
    throws InterruptedException {
    for (Thread t : threads) {
      t.join();
    }
  }
}
